29 May 2025

> [!WARNING]
>
> #### Tiered Policy naming changes
>
> If you are upgrading your Calico cluster to v3.30.1, please see [the release notes from Calico v3.29.4](https://github.com/projectcalico/calico/blob/v3.29.4/release-notes/v3.29.4-release-notes.md) as naming of policies in the default tier may have changed.
>
> Clusters meeting the following criteria may be affected:
>
> 1. You previously had Calico v3.29.1, v3.29.2, or v3.29.3 installed
> 2. You created policies in the default tier while those versions were installed
> 3. Your cluster has never been upgraded to v3.29.4 (even if you have upgraded to v3.30.0 already)

#### Bug fixes

- ebpf: Fixed attaching bpf programs by atomically replacing the old program rather than attaching new and detaching old. [calico 10454](https://github.com/projectcalico/calico/pull/10454) (@sridhartigera)
- Disable WatchList in Calico API server, fixing issue with stuck Namespace termination. [calico 10440](https://github.com/projectcalico/calico/pull/10440) (@tmjd)
- Policies created prior to v3.28.0 have their name retained across upgrade. Policies created in the default tier with version v3.29.[0-3] will have their names changed from `default.name` to `name`. [calico 10418](https://github.com/projectcalico/calico/pull/10418) (@MichalFupso)
- eBPF - Fix forwarding of packets to kubevirt pods when in bridge mode. [calico 10415](https://github.com/projectcalico/calico/pull/10415) (@sridhartigera)
- Add missing tiers permissions for flannel migration controller [calico 10385](https://github.com/projectcalico/calico/pull/10385) (@caseydavenport)
- Fix flannel migration use of deprecated flag "delete-local-data" [calico 10379](https://github.com/projectcalico/calico/pull/10379) (@caseydavenport)

#### Other changes

- Introduces a shorthand for StagedNetworkPolicy -> snp, StagedGlobalNetworkPolicy -> sgnp and StagedKubernetesNetworkPolicy -> sknp [calico 10424](https://github.com/projectcalico/calico/pull/10424) (@MichalFupso)
- Update Operator Helm values to support custom DNS settings [calico 10406](https://github.com/projectcalico/calico/pull/10406) (@caseydavenport)
